var Gtop = Gtop || {};
Gtop.Writer = function() {

    var _curDateTime = null;
    var _nowOnAirData = null;
    var _recommendMovieData = null;
    var _recommendProgramData = null;
    var _contentsNewsData = null;
    var _webNewsData = null;
    var _recommendContentsData = null;
    var _anaFacebookData = null;
    var _anaHiyokoFacebookData = null;
    var _programBannerData = null;

    Object.defineProperties(this, {
        curDateTime: {
            get: function () { return _curDateTime; }
            , set: function (value) { _curDateTime = value; }
        },
        nowOnAirData: {
            get: function () { return _nowOnAirData; }
            , set: function (value) { _nowOnAirData = value; }
        },
        recommendMovieData: {
            get: function () { return _recommendMovieData; }
            , set: function (value) { _recommendMovieData = value; }
        },
        recommendProgramData: {
            get: function () { return _recommendProgramData; }
            , set: function (value) { _recommendProgramData = value; }
        },
        contentsNewsData: {
            get: function () { return _contentsNewsData; }
            , set: function (value) { _contentsNewsData = value; }
        },
        webNewsData: {
            get: function () { return _webNewsData; }
            , set: function (value) { _webNewsData = value; }
        },
        recommendContentsData: {
            get: function () { return _recommendContentsData; }
            , set: function (value) { _recommendContentsData = value; }
        },
        anaFacebookData: {
            get: function () { return _anaFacebookData; }
            , set: function (value) { _anaFacebookData = value; }
        },
        anaHiyokoFacebookData: {
            get: function () { return _anaHiyokoFacebookData; }
            , set: function (value) { _anaHiyokoFacebookData = value; }
        },
        programBannerData: {
            get: function () { return _programBannerData; }
            , set: function (value) { _programBannerData = value; }
        }
    });

}
Gtop.Writer.prototype = {

    writeNowOnAir: function (callback) {
        if (0 <= this.curDateTime.getHours() && this.curDateTime.getHours() < 4) {
            var tvFormationEndDate = new Date(
                this.curDateTime.getFullYear()
                , this.curDateTime.getMonth()
                , this.curDateTime.getDate()
                , 3
                , 59
                , 59
            );
        } else {
            var tvFormationEndDate = new Date(
                this.curDateTime.getFullYear()
                , this.curDateTime.getMonth()
                , this.curDateTime.getDate()
                , 3
                , 59
                , 59
            );
            tvFormationEndDate.setDate(tvFormationEndDate.getDate() + 1);
        }
        var week = ['日', '月', '火', '水', '木', '金', '土'];
        var html = '<div class="ttl-today">';
        html += '<p class="text-date">'+this.curDateTime.getFullYear()
        html += '<span class="dot">.</span>';
        html += (Number(this.curDateTime.getMonth())+1);
        html += '<span class="dot">.</span>';
        html += ('0'+String(this.curDateTime.getDate())).slice(-2);
        html += '<span class="week">（'+week[this.curDateTime.getDay()]+'）</span>';
        html += '</p>';
        html += '<a href="/tvprogram/" class="link"><span>番組表</span></a>';
        html += '</div>';

        if (this.nowOnAirData !== null) {
            var data = this.nowOnAirData;

            data = this.sortDateTime(data, 'startTime');

            html += '<div class="box-onair mCustomScrollbar">';
            html += '<ul class="smp-carousel owl-theme">';
            for (var index = 0; index < data.length; index++) {
                var broadcastStartTime = this.convertDateObject(data[index].startTime);
                var broadcastEndTime = this.convertDateObject(data[index].endTime);
                if (this.curDateTime.getTime() < broadcastEndTime.getTime()) {
                    if (broadcastStartTime.getTime() <= this.curDateTime.getTime()) {
                        html += '<li class="now item">';
                    } else if (broadcastStartTime.getTime() <= tvFormationEndDate.getTime()) {
                        html += '<li class="item">';
                    } else {
                        break;
                    }
                    if (data[index].siteUri) {
                        if (data[index].newWin === "0") {
                            html += '<a href="'+data[index].siteUri+'">';
                        } else {
                            html += '<a href="'+data[index].siteUri+'" target="_blank">';
                        }
                    } else {
                        html += '<a>';
                    }
                    var listTitle = data[index].title;
                    if (data[index].name) {
                        listTitle = data[index].name;
                    }
                    if (data[index].logoImg) {
                        html += '<p class="text-onair-img"><img src="'+data[index].logoImg+'" alt="'+listTitle+'"></p>';
                    } else {
                        html += '<p class="text-onair-img"><img src="./img/nowonair_noimage.jpg" alt="'+listTitle+'"></p>';
                    }
                    html += '<p class="text-onair-time"><span>'+broadcastStartTime.getHours()+':'+('0'+String(broadcastStartTime.getMinutes())).slice(-2)+'</span></p>';
                    html += '<p class="text-onair-name"><span>'+listTitle+'</span></p>';
                    html += '</a></li>';
                }
            }
            html += '</ul>';
            html += '</div>';

            var target = document.getElementById("onair_top");
            if (typeof target !== "undefined" && target !== null) {
                if (typeof target.innerHTML !== "undefined") {
                    target.innerHTML = html;
                }
            }
            if (callback !== undefined) {
                callback();
            };
        };
    },

    writeRecommendMovie: function (index, callback) {
        var html = '';
        var week = ['日', '月', '火', '水', '木', '金', '土'];

        if (this.recommendMovieData !== null) {
            var broadcastData = null;
            if (this.nowOnAirData !== null) {
                broadcastData = this.nowOnAirData;
                broadcastData = this.sortDateTime(broadcastData, 'startTime');
            }

            var data = this.recommendMovieData;
            data = this.sortDisplayOrder(data);

            var timeStartStamps = data[index].recommend_movie_broadcast_start_time.split(':');
            var startTime = new Date(
                this.curDateTime.getFullYear()
                , this.curDateTime.getMonth()
                , this.curDateTime.getDate()
                , Number(timeStartStamps[0])
                , Number(timeStartStamps[1])
            );
            var timeEndStamps = data[index].recommend_movie_time_scale.split(':');
            var endTime = new Date(
                this.curDateTime.getFullYear()
                , this.curDateTime.getMonth()
                , this.curDateTime.getDate()
                , Number(timeEndStamps[0])
                , Number(timeEndStamps[1])
            );
            if (startTime.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() < endTime.getTime()) {
                htmlA = '<div class="marquee"><span class="marquee-inner">'+data[index].recommend_movie_description+'</span></div>';
                var targetA = document.getElementsByClassName("talk")[0];
                if (typeof targetA !== "undefined" && targetA !== null) {
                    if (typeof targetA.innerHTML !== "undefined") {
                        targetA.innerHTML = htmlA;
                    }
                }
                var htmlB = '<a href="javascript:void(0)">';
                if (data[index].recommend_movie_url !== '') {
                    if (data[index].new_window_st === '0') {
                        htmlB = '<a href="'+data[index].recommend_movie_url+'">';
                    } else {
                        htmlB = '<a href="'+data[index].recommend_movie_url+'" target="_blank">';
                    }
                }
                htmlB += '<p class="mov-name">'+data[index].recommend_movie_title+'</p>';
                var tempHtmlB = '<p class="mov-date">　</p>';
                if (broadcastData) {
                    for (var indexC = 0; indexC < broadcastData.length; indexC++) {
                        if ((broadcastData[indexC].m_program_id === data[index].m_program_id) && (broadcastData[indexC].reBroadcastStamp === '0')){
                            broadcastDate = this.convertDateObject(broadcastData[indexC].startTime);
                            if (broadcastDate.getTime() >= this.curDateTime.getTime()) {
                                var strHour = broadcastDate.getHours();
                                var strMonth = broadcastDate.getMonth() + 1;
                                var strDate = broadcastDate.getDate();
                                var strWeek = week[broadcastDate.getDay()];
                                if (0 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) < 4) {
                                    strHour = '深夜'+ broadcastDate.getHours();
                                    var tempDate = new Date(
                                        broadcastDate.getFullYear()
                                        , broadcastDate.getMonth()
                                        , broadcastDate.getDate() - 1
                                        , broadcastDate.getHours()
                                        , broadcastDate.getMinutes()
                                    );
                                    strMonth = tempDate.getMonth() + 1;
                                    strDate = tempDate.getDate();
                                    strWeek = week[tempDate.getDay()];
                                } else if (4 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) < 12) {
                                    strHour = '午前'+ broadcastDate.getHours();
                                } else if (12 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) <= 23) {
                                    strHour = '午後'+ (Number(broadcastDate.getHours())-12);
                                }
                                var tempHtmlB = '<p class="mov-date">'+strMonth+'月';
                                tempHtmlB += strDate+'日';
                                tempHtmlB += '('+strWeek+')';
                                tempHtmlB += ' '+strHour+'時'+('0'+String(broadcastDate.getMinutes())).slice(-2)+'分</p>';
                                break;
                            }
                        }
                    }
                }
                htmlB += tempHtmlB;
                var targetB = document.getElementsByClassName("mov-info")[0];
                if (typeof targetB !== "undefined" && targetB !== null) {
                    if (typeof targetB.innerHTML !== "undefined") {
                        targetB.innerHTML = htmlB;
                    }
                }
                callback();
            }
        }
    },

    writeRecommendProgram: function (callback) {
        var html = '<h2 class="ttl-recommend"><span>おすすめ番組</span></h2>';
        html += '<div class="recommend-contents owl-theme">';
        var week = ['日', '月', '火', '水', '木', '金', '土'];

        if (this.recommendProgramData !== null) {
            var broadcastData = null;
            if (this.nowOnAirData !== null) {
                broadcastData = this.nowOnAirData;
                broadcastData = this.sortDateTime(broadcastData, 'startTime');
            }

            var backgrounds = {};

            var data = this.recommendProgramData;
            data = this.sortDateTime(data, 'recommend_program_date');

            for (var index = 0; index < data.length; index++) {
                if (Object.keys(data[index]).length !== 0) {
                    var targetDate = this.convertDateObject(data[index].recommend_program_date);
                    if (targetDate.getFullYear() === this.curDateTime.getFullYear() && targetDate.getMonth() === this.curDateTime.getMonth() && targetDate.getDate() === this.curDateTime.getDate()) {
                        var dataB = data[index].programs;
                        dataB = this.sortDisplayOrder(dataB);
                        for (var indexB = 0; indexB < dataB.length; indexB++) {
                            var programStartTime = new Date(
                                targetDate.getFullYear()
                                , targetDate.getMonth()
                                , targetDate.getDate()
                                , Number(dataB[indexB].recommend_program_broadcast_start_time.split(':')[0])
                                , Number(dataB[indexB].recommend_program_broadcast_start_time.split(':')[1])
                            );
                            var programEndTime = new Date(
                                targetDate.getFullYear()
                                , targetDate.getMonth()
                                , targetDate.getDate()
                                , Number(dataB[indexB].recommend_program_time_scale.split(':')[0])
                                , Number(dataB[indexB].recommend_program_time_scale.split(':')[1])
                            );
                            if (programStartTime.getTime() > this.curDateTime.getTime() || this.curDateTime.getTime() >= programEndTime.getTime()) { continue; }
                            html += '<div class="item">';
                            if (dataB[indexB].recommend_program_movie_url) {
                                html += '<a href="https://www.youtube.com/watch?v='+dataB[indexB].recommend_program_movie_url+'" class="popup-modal">';
                                html += '<p class="recommend-img"><img src="https://i.ytimg.com/vi/'+dataB[indexB].recommend_program_movie_url+'/mqdefault.jpg"></p>';
                            } else {
                            	if (dataB[indexB].new_window_st === '0') {
                                	html += '<a href="'+dataB[indexB].recommend_program_url+'">';
                                } else {
                                	html += '<a href="'+dataB[indexB].recommend_program_url+'" target="_blank">';
                                }
                                html += '<p class="recommend-img"><img src="'+dataB[indexB].recommend_program_image+'"></p>';
                            }
                            html += '</a>';

                            if (dataB[indexB].new_window_st === '0') {
                                html += '<a href="'+dataB[indexB].recommend_program_url+'" class="recommend-text">';
                            } else {
                                html += '<a href="'+dataB[indexB].recommend_program_url+'" class="recommend-text" target="_blank">';
                            }
                            html += '<p class="recommend-name">'+dataB[indexB].recommend_program_title+'</p>';
                            if (broadcastData) {
                                for (var indexC = 0; indexC < broadcastData.length; indexC++) {
                                    broadcastDate = this.convertDateObject(broadcastData[indexC].startTime);
                                    broadcastEndDate = this.convertDateObject(broadcastData[indexC].endTime);
                                    var nowDate = this.curDateTime.toLocaleDateString();
                                    var nowHours = Number(this.curDateTime.getHours());
                                    var nowMinutes = Number(this.curDateTime.getMinutes());
                                    var bcDate = broadcastDate.toLocaleDateString();
                                    var bcHours = Number(broadcastDate.getHours());
                                    var bcMinutes = Number(broadcastDate.getMinutes());
                                    var bcPgmId = Number(broadcastData[indexC].m_program_id);
                                    if (broadcastData[indexC].m_program_id === dataB[indexB].m_program_id && (
                                               (broadcastEndDate > this.curDateTime)                                                   // 現在以降
                                               // || ((bcDate == nowDate) && (nowHours <= bcHours))                                   // 同日 放送時間が1時間以上後
                                               // || ((bcDate == nowDate) && (nowHours == bcHours) && (nowMinutes <= bcMinutes))      // 同日 放送時間が1分以上後
                                               // || ((bcDate == nowDate) && (4 <= bcHours))                                          // 同日 4時以降
                                            )
                                        ) {
                                        if (broadcastDate.getTime() >= targetDate.getTime()) {
                                            var strHour = broadcastDate.getHours();
                                            var strMonth = broadcastDate.getMonth() + 1;
                                            var strDate = broadcastDate.getDate();
                                            var strWeek = week[broadcastDate.getDay()];
                                            if (0 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) < 4) {
                                                strHour = '深夜'+ broadcastDate.getHours();
                                                var tempDate = new Date(
                                                    broadcastDate.getFullYear()
                                                    , broadcastDate.getMonth()
                                                    , broadcastDate.getDate() - 1
                                                    , broadcastDate.getHours()
                                                    , broadcastDate.getMinutes()
                                                );
                                                strMonth = tempDate.getMonth() + 1;
                                                strDate = tempDate.getDate();
                                                strWeek = week[tempDate.getDay()];
                                            } else if (4 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) < 12) {
                                                strHour = '午前'+ broadcastDate.getHours();
                                            } else if (12 <= Number(broadcastDate.getHours()) && Number(broadcastDate.getHours()) <= 23) {
                                                strHour = '午後'+ (Number(broadcastDate.getHours())-12);
                                            }
                                            html += '<p class="recommend-date">'+strMonth+'月';
                                            html += strDate+'日';
                                            html += '('+strWeek+')';
                                            html += ' '+strHour+'時'+('0'+String(broadcastDate.getMinutes())).slice(-2)+'分</p>';
                                            break;
                                        }
                                    }
                                }
                            }
                            html += '</a></div>';
                        }
                    }
                }
            }
        }
        html += '</div>';
        var target = document.getElementsByClassName("recommend-wrap")[0];
        if (typeof target !== "undefined" && target !== null) {
            if (typeof target.innerHTML !== "undefined") {
                target.innerHTML = html;
            }
        }
        callback();
    },

    writeContentsNews: function (callback) {
        var html = '';
        var week = ['日', '月', '火', '水', '木', '金', '土'];

        if (this.contentsNewsData !== null) {
            var data = this.contentsNewsData;
            data = this.sortDisplayOrder(data);
            var backgrounds = {};
            for (var index = 0; index < data.length; index++) {
                var dispFromDate = new Date(
                    data[index].display_date_from_year
                    , Number(data[index].display_date_from_month)-1
                    , data[index].display_date_from_day
                    , data[index].display_time_from_hour
                    , data[index].display_time_from_minute
                );
                var dispToDate = new Date(
                    data[index].display_date_to_year
                    , Number(data[index].display_date_to_month)-1
                    , data[index].display_date_to_day
                    , data[index].display_time_to_hour
                    , data[index].display_time_to_minute
                );
                var updateDate = new Date(
                    data[index].update_date_year
                    , Number(data[index].update_date_month)-1
                    , data[index].update_date_day
                );
                if (dispFromDate.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() <= dispToDate.getTime()) {
                    html += '<li class="item-contents-small">';
                    if (data[index].new_window_st === "0") {
                        html += '<a href="'+data[index].contents_url+'">';
                    } else {
                        html += '<a href="'+data[index].contents_url+'" target="_blank">';
                    }
                    if (data[index].contents_image !== '') {
                        html += '<div class="thumb-contents-small"><img src="/img/contents_news/'+data[index].contents_image_dir+data[index].contents_image+'" alt="'+data[index].contents_title+'"></div>';
                    } else {
                        html += '<div class="thumb-contents-small"><img src="/img/program/'+data[index].program_image_dir+data[index].program_logo_image+'" alt="'+data[index].contents_title+'"></div>';
                    }

                    html += '<p class="description-contents-small"><span class="day-contents-small">';
                    if ((this.curDateTime.getTime()-updateDate.getTime()) < (1000*60*60*24*6)) {
                        html += '<span class="ico-new">NEW</span>';
                    }
                    html += Number(data[index].update_date_month)+'月';
                    html += data[index].update_date_day+'日';
                    html += '('+week[updateDate.getDay()]+')</span>';
                    html += '<span class="description">'+data[index].contents_title+'<br>'+data[index].contents_description+'</span></p>';
                    html += '</a></li>';
                }
            }

            var target = document.getElementById("contents-news");
            target.innerHTML = html;

            callback();
        }
    },

    writeWebNews: function (callback) {
        var html = '';
        var week = ['日', '月', '火', '水', '木', '金', '土'];

        if (this.webNewsData !== null) {
            var data = this.webNewsData.documentElement.getElementsByTagName('item');
            var pattern = /（[0-9]{1,2}\/[0-9]{1,2} [0-9]{1,2}:[0-9]{1,2}）$/

            for (var index = 0; index < data.length; index++) {
                if (data[index].getElementsByTagName('GENRE')[0].textContent !== 'other') {
                    var updateDate = this.convertDateObject(data[index].getElementsByTagNameNS('http://purl.org/dc/elements/1.1/', 'date')[0].textContent);
                    html += '<li class="item-contents-small">';
                    if (data[index].getElementsByTagName('GENRE')[0].textContent === 'rank3') {
                        var url = data[index].getElementsByTagName('link')[0].textContent.replace(/abc_3_/g, "abc_2_"); // ランクが3に変わってもページが生成されないので、こちらでURLをひねる
                        html += '<a href="'+url+'">';
                    } else {
                        html += '<a href="'+data[index].getElementsByTagName('link')[0].textContent+'">';
                    }
                    html += '<div class="thumb-contents-small"><img src="'+data[index].getElementsByTagName('image')[0].textContent+'"></div>';
                    html += '<p class="description-contents-small"><span class="day-contents-small">';
                    var str = data[index].getElementsByTagName('title')[0].textContent;
                    html += (Number(updateDate.getMonth())+1)+'月';
                    html += ('0'+String(updateDate.getDate())).slice(-2)+'日';
                    html += '('+week[updateDate.getDay()]+')</span>';
                    html += '<span class="description">'+str.replace(pattern, '')+'</span></p>';
                    html += '</a></li>';
                }
            }

            var target = document.getElementById("web-news");
            target.innerHTML = html;
            callback();
        };
    },

    writePrsentRecruitment: function (callback) {
        var html = '';

        if (this.recommendContentsData !== null) {
            var dataBefore = this.recommendContentsData;
            var data = [];
            for (var index = 0; index < dataBefore.length; index++) {
                if (dataBefore[index].contents_category_id === '4' || dataBefore[index].contents_category_id === '8' || dataBefore[index].contents_category_id === '9') {
                    data.push(dataBefore[index]);
                }
            }

            data = this.sortDisplayOrder(data);

            for (var index = 0; index < data.length; index++) {
                var dispFromDate = new Date(
                    data[index].display_date_from_year
                    , Number(data[index].display_date_from_month)-1
                    , data[index].display_date_from_day
                    , data[index].display_time_from_hour
                    , data[index].display_time_from_minute
                );
                var dispToDate = new Date(
                    data[index].display_date_to_year
                    , Number(data[index].display_date_to_month)-1
                    , data[index].display_date_to_day
                    , data[index].display_time_to_hour
                    , data[index].display_time_to_minute
                );
                if (dispFromDate.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() <= dispToDate.getTime()) {
                    html += '<li class="item-contents-small">';
                    if (data[index].new_window_st === "0") {
                        html += '<a href="'+data[index].contents_url+'">';
                    } else {
                        html += '<a href="'+data[index].contents_url+'" target="_blank">';
                    }
                    html += '<div class="thumb-contents-small">';
                    html += '<img src="/img/recommend_contents/'+data[index].contents_image_dir+data[index].contents_image+'" alt="'+data[index].contents_title+'"></div>';
                    html += '<p class="description-contents-small">';
                    html += '<span class="description">'+data[index].contents_title+'<br>'+data[index].contents_description+'</span></p>'
                    html += '</a></li>';
                }
            }

            var target = document.getElementById("present");
            target.innerHTML = html;
            callback();
        }
    },

    writeAnnouncer: function () {
        var html = '';
        var week = ['日', '月', '火', '水', '木', '金', '土'];

        if (this.recommendContentsData !== null) {
            var dataBefore = this.recommendContentsData;
            var data = [];
            for (var index = 0; index < dataBefore.length; index++) {
                if (dataBefore[index].contents_category_id === '3') {
                    data.push(dataBefore[index]);
                };
            };

            data = this.sortDisplayOrder(data);

            var count = 0;

            //アナブログのデータを整理
            let sort = function(data, sortKey, keyword)
            {
                data.sort(function(a,b){
                        if (keyword === 'desc') {
                            return a[sortKey] > b[sortKey] ? -1: 1;
                        } else if (keyword === 'asc') {
                            return a[sortKey] < b[sortKey] ? -1: 1;
                        }
                    }
                );
                return data;
            }
            let annTimelineBefore = this.anaFacebookData;
            let annTimelineData = annTimelineBefore.posts.data;
            let annTimeline = sort(annTimelineData, 'created_date', 'desc');
            let annHiyokoTimelineBefore = this.anaHiyokoFacebookData;
            let annHiyokoTimelineData = annHiyokoTimelineBefore.posts.data;
            let annHiyokoTimeline = sort(annHiyokoTimelineData, 'created_date', 'desc');
            let articleData;

            for (var index = 0; index < data.length; index++) {
                if (count > 2) break;
                var dispFromDate = new Date(
                    data[index].display_date_from_year
                    , Number(data[index].display_date_from_month)-1
                    , data[index].display_date_from_day
                    , data[index].display_time_from_hour
                    , data[index].display_time_from_minute
                );
                var dispToDate = new Date(
                    data[index].display_date_to_year
                    , Number(data[index].display_date_to_month)-1
                    , data[index].display_date_to_day
                    , data[index].display_time_to_hour
                    , data[index].display_time_to_minute
                );
                if (dispFromDate.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() <= dispToDate.getTime()) {
                    //facebook or blog or hiyoko
                    let category = '';
                    if (data[index].contents_url === 'https://www.facebook.com/asahi.ana/') { category = 'ann'; }
                    if (data[index].contents_url.match(/^\/ann\/blog/)) { category = 'blog'; }
                    if (data[index].contents_url.match(/^\/ann\/hiyoko/)) { category = 'hiyoko'; }

                    html += '<li class="item-contents-middle';
                    if (category !== '') { html += ' ann'; }
                    if (count === 2) { html += ' onlyPC'; }
                    html += '">';

                    var imgSrc = '/img/recommend_contents/'+data[index].contents_image_dir+data[index].contents_image;
                    var discription = '<span class="description">'+data[index].contents_description+'</span>';
                    if (category !== '') {
                        if (category === 'ann' || category === 'blog') {
                            articleData = annTimeline[0];
                        } else if (category === 'hiyoko') {
                            articleData = annHiyokoTimeline[0];
                        }
                        if (articleData.attachments[0] != undefined) {
                            imgSrc = articleData.attachments[0].image;
                        }
                        let year = Number(articleData.created_date.substr(0, 4));
                        let month = Number(articleData.created_date.substr(4, 2)) - 1;
                        let date = Number(articleData.created_date.substr(6, 2));
                        var annUpdateTime = new Date(year, month, date, 0, 0, 0);
                        var newIcon = '';
                        if (annUpdateTime.getFullYear() >= this.curDateTime.getFullYear() && annUpdateTime.getMonth() >= this.curDateTime.getMonth() && annUpdateTime.getDate() >= this.curDateTime.getDate()) {
                            newIcon = '<span class="ico-new">NEW</span>';
                        };
                        var result = '【'+articleData.title+'】by'+articleData.writer_name;
                        if (result.length > 0) {
                            discription = '<span class="day-contents-middle">';
                            discription += newIcon;
                            discription += (Number(annUpdateTime.getMonth())+1)+'月';
                            discription += ('0'+String(annUpdateTime.getDate())).slice(-2)+'日';
                            discription += '('+week[annUpdateTime.getDay()]+')';
                            discription += '</span><span class="description">';
                            discription += result;
                            discription += ' <span class="more">続きを見る</span>';
                        }
                    };

                    if (data[index].new_window_st === "0") {
                        html += '<a href="'+data[index].contents_url+'">';
                    } else {
                        html += '<a href="'+data[index].contents_url+'" target="_blank">';
                    };
                    if (count == 1) {
                        html += '<div id="div_ana" class="thumb-contents-middle"><img src="'+imgSrc+'" alt="'+data[index].contents_title+'"></div>';
                        html += '<div style="visibility:hidden; display:none;"><img id="img_ana" src="'+imgSrc+'"></div>';
                    } else {
                        html += '<div class="thumb-contents-middle"><img src="'+imgSrc+'" alt="'+data[index].contents_title+'"></div>';
                    }
                    html += '<p class="description-contents-middle">';
                    html += '<span class="ttl-contents-middle">'+data[index].contents_title+'</span>';
                    html += discription;
                    html += '</p></a></li>';
                    count++;
                };
            };

            var target = document.getElementById("announcer");
            target.innerHTML = html;
        };
    },

    writeVideoDistribution: function () {
        var html = '';

        if (this.recommendContentsData !== null) {
            var dataBefore = this.recommendContentsData;
            var data = [];
            for (var index = 0; index < dataBefore.length; index++) {
                if (dataBefore[index].contents_category_id === '1') {
                    data.push(dataBefore[index]);
                }
            }

            data = this.sortDisplayOrder(data);

            for (var index = 0; index < data.length; index++) {
                var dispFromDate = new Date(
                    data[index].display_date_from_year
                    , Number(data[index].display_date_from_month)-1
                    , data[index].display_date_from_day
                    , data[index].display_time_from_hour
                    , data[index].display_time_from_minute
                );
                var dispToDate = new Date(
                    data[index].display_date_to_year
                    , Number(data[index].display_date_to_month)-1
                    , data[index].display_date_to_day
                    , data[index].display_time_to_hour
                    , data[index].display_time_to_minute
                );
                if (dispFromDate.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() <= dispToDate.getTime()) {
                    html += '<li class="item-contents-middle">';
                    if (data[index].new_window_st === "0") {
                        html += '<a href="'+data[index].contents_url+'">';
                    } else {
                        html += '<a href="'+data[index].contents_url+'" target="_blank">';
                    }
                    html += '<div class="thumb-contents-middle">'
                    html += '<img src="/img/recommend_contents/'+data[index].contents_image_dir+data[index].contents_image+'" alt="'+data[index].contents_title+'"></div>';
                    html += '<p class="description-contents-middle">';
                    html += '<span class="ttl-contents-middle">'+data[index].contents_title+'</span></p>'
                    html += '</a></li>';
                }
            }

            var target = document.getElementById("movie");
            target.innerHTML = html;
        }
    },

    writeProgramBanner: function () {
        var html = '<div class="wrap-contents">'
        + '<div class="wrap-ttl-programlist">'
        + '<h2 class="ttl-programlist">番組一覧</h2>'
        + '<a href="/programlist/" class="other-program">その他の番組はこちら</a>'
        + '</div>';

        if (this.programBannerData !== null) {
            var data = this.programBannerData;

            data = this.sortDisplayOrder(data);

            for (var index = 0; index < data.length; index++) {
                if (index % 6 === 0) {
                    html += '<ul class="list-bnr">'
                }
                html += '<li><a href="'+data[index].program_site_url+'"><img src="'+data[index].program_logo_image+'" alt="'+data[index].program_name+'"></a></li>'
                if (index % 6 === 5 || index === data.length-1) {
                    html += '</ul>'
                }
            }
        };

        var target = document.getElementsByClassName("wrap-programlist");
        target[0].innerHTML = html;
    },

    sortDisplayOrder: function (data) {
        data.sort(function(a,b){
            if(Number(a.display_order) < Number(b.display_order)) return -1;
            if(Number(a.display_order) > Number(b.display_order)) return 1;
            return 0;
        });
        return data;
    },

    sortDateTime: function (data, key, asc) {
        ascFlag = (asc !== undefined ? asc: 'ASC');
        if (ascFlag === 'DESC') {
            data.sort(function(a,b){
                var dateA = this.convertDateObject(a[key]);
                var dateB = this.convertDateObject(b[key]);
                if(dateA.getTime() < dateB.getTime()) return 1;
                if(dateA.getTime() > dateB.getTime()) return -1;
                return 0;
            }.bind(this));
            return data;
        } else {
            data.sort(function(a,b){
                var dateA = this.convertDateObject(a[key]);
                var dateB = this.convertDateObject(b[key]);
                if(dateA.getTime() > dateB.getTime()) return 1;
                if(dateA.getTime() < dateB.getTime()) return -1;
                return 0;
            }.bind(this));
            return data;
        }
    },

    convertDateObject: function (stringDateTime) {
        var pattern = '';
        var result = null;

        pattern = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})\+(\d{2})(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2]) - 1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
                , Number(result[6])
            );
            return updateDate;
        }

        pattern = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})\+(\d{2}):(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
            );
            return updateDate;
        }

        pattern = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
                , Number(result[6])
            );
            return updateDate;
        }

        pattern = /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
            );
            return updateDate;
        }

    }
}